--[[Requires speedtest-cli (https://github.com/sivel/speedtest-cli)
$ wget -O speedtest-cli https://raw.github.com/sivel/speedtest-cli/master/speedtest_cli.py
$ chmod +x speedtest-cli
$ sudo mv speedtest-cli /usr/local/bin/speedtest-cli
]]
local speedtest_cli = {}

function speedtest_cli:init(config)
  speedtest_cli.triggers = utilities.triggers(self.info.username, config.cmd_pat):t('speedtest', true).table
end

function speedtest_cli:action(msg, config)
  utilities.send_typing(msg.chat.id, 'typing')
  local result = run_command('speedtest-cli --share')
  local url = result:match("Share results: (.*)")
  utilities.send_typing(msg.chat.id, 'upload_photo')
  local photo = download_to_file(url, 'speedtest_cli.png')
  if not photo then
    utilities.send_reply(msg, config.errors.connection)
    return
  end
  utilities.send_photo(msg.chat.id, photo, nil, msg.message_id) 
end

return speedtest_cli